function split(a,b)
local c={}
if type(b)=="nil" then
    b=","
end
while string.find(a,b) do
  c[#c+1]=string.sub(a,1,(string.find(a,b)-1))
  a=string.sub(a,(string.find(a,b)+1))
end
if a~="" then
    c[#c+1]=a
end
return c
end

--udelat ukladani pres bintable
--dodelat cas
--dodelat udalosti
--dodelat pruchody

--liff core (liff.lua)
liff={}
liff.actions={}
liff.command={}
liff.loop=1
liff.turns=0
liff.title="liff engine (embryo)"
liff.INVENTORY=0
liff.hh=9
liff.mm=9
liff.day=1
liff.version=0

w={}
w.desc={}
w.name={}
w.where={}
w.take={}
w.talk={}
w.exits={}

function liff.turn()
    liff.turns=liff.turns+1
end

function liff.parse(inp)
    local first
    liff.command=split(inp," ")
    first=liff.command[1]
    if type(liff.actions[first])=="function" then
        liff.actions[first]()
    elseif w.exits[liff.here] and w.exits[liff.here][first] then
        liff.enterRoom(w.exits[liff.here][first])
    else
        liff.output("Nerozumm pkazu. :-(")
    end
end

function liff.showPic(pic)
    return false
end

function liff.output(o)
    print(o)
end

function liff.main()
    liff.output(liff.title)
    liff.enterRoom(liff.here)
   while liff.loop==1 do
        inp=io.read()
        liff.parse(inp)
        liff.turn()
        liff.output(" ")
    end
end

function liff.enterRoom(no)
    liff.here=no
    liff.examineRoom(no)
end

function liff.examineRoom(no)
    local m, n, k, v
    liff.output(string.upper(w.name[no]))
    if (type(w.desc[no]=="string")) then
        liff.output(w.desc[no])
    end
    m={}
    for k,v in pairs(w.where) do
        if (v==no) then
            m[#m+1]=w.name[k]
        end
    end
    if (#m>0) then
        liff.output("Je tu "..table.concat(m,", ")..".")
    end
    n={}
    for k,v in pairs(w.exits[liff.here] or {}) do
        n[#n+1]=k
    end
    if #n>0 then
        liff.output("Me pokraovat:"..table.concat(n,", "))
    end
    
end

function liff.getId(word)
    local r=nil
    for k,v in pairs(w.name) do
        if v==word and w.where[k]==liff.here then
            r=k
        end
    end
    for k,v in pairs(w.name) do
        if v==word and w.where[k]==liff.INVENTORY then
            r=k
        end
    end
    return r
end

--world

function room(n,d)
    w.name[#w.name+1]=n
    w.desc[#w.name]=d
    return #w.name
end

liff.NOWHERE=room("Nowhere","You are outside the time and space...")
liff.here=liff.NOWHERE

function item(n,d,wh)
    w.name[#w.name+1]=n
    w.desc[#w.name]=d
    if wh then
        w.where[#w.name]=wh
    else
        w.where[#w.name]=liff.NOWHERE
    end
    w.take[#w.name]=1
    return #w.name
end

function decor(n,d,wh)
    w.name[#w.name+1]=n
    w.desc[#w.name]=d
    if wh then
        w.where[#w.name]=wh
    else
        w.where[#w.name]=liff.NOWHERE
    end
    w.take[#w.name]=0
    return #w.name
end

function actor(n,d,wh)
    w.name[#w.name+1]=n
    w.desc[#w.name]=d
    if wh then
        w.where[#w.name]=wh
    else
        w.where[#w.name]=liff.NOWHERE
    end
    w.take[#w.name]=0
    w.talk[#w.name]=0
    return #w.name
end

function way(from,how,to)
    if how=="sj" then
        front="sever"
        back="jih"
    elseif how=="vz" then
        front="vchod"
        back="zpad"
    elseif how=="dv" then
        front="dovnit"
        back="ven"
    elseif how=="nd" then
        front="nahoru"
        back="dol"
    end
    if w.exits[from]==nil then
        w.exits[from]={}
    end
    m=w.exits[from]
    m[back]=to
    if w.exits[to]==nil then
        w.exits[to]={}
    end
    n=w.exits[to]
    n[front]=from
end
